#include "vrsapi.h"

HWND VRSAPIRunAndFindWindow()
{
   // Check if we are allready running. If so just return the window
   HWND hwndFindWindow = VRSAPIFindWindow();
   if (hwndFindWindow != NULL) return hwndFindWindow;

   char szVRSExePath[MAX_PATH];

   // Find the local program files folder
   strcpy(szVRSExePath, "C:\\Program Files"); // Default value if the Registry fails
	HKEY hKey;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\Microsoft\\Windows\\CurrentVersion"), 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS) {
	  DWORD dwSize = MAX_PATH - 32;
	  RegQueryValueEx(hKey, TEXT("ProgramFilesDir"), 0, NULL, (BYTE*)szVRSExePath, &dwSize);
	  RegCloseKey(hKey);
}

   // VRS is installed in C:\Program Files\NCH Swift Sound\VRS\vrs.exe
   strcat(szVRSExePath, "\\NCH Swift Sound\\VRS\\vrs.exe");

   // Run the VRS now (in the background)
   if (WinExec(szVRSExePath, SW_HIDE) <= 31) return NULL;

   // Wait up to 4000ms for run to be complete
   for (int i = 0; i < 40; i++) {
     Sleep(100);
     hwndFindWindow = VRSAPIFindWindow();
     if (hwndFindWindow != NULL) return hwndFindWindow;
   }

   // We have failed so return an error
   return NULL;
}

void VRSAPISetRecordingData(int nChannelZeroBased,
                                const char* szData,
                                   bool bPersists)
{
   HWND hWndVRS = VRSAPIFindWindow();
   if (hWndVRS == NULL) { // if VRS is not currently running
      hWndVRS = VRSAPIRunAndFindWindow(); //Run VRS
      if (hWndVRS == NULL) return;
   }
   ATOM atomExtraInfo = GlobalAddAtom(szData);
   SendMessage(hWndVRS, MCI_SET,
                  (WPARAM)MAKELONG(nChannelZeroBased, bPersists),
                              atomExtraInfo);
   GlobalDeleteAtom(atomExtraInfo);
}
